#Pyrogram imports
from pyrogram import Client, filters
from pyrogram.types import InlineKeyboardMarkup, InlineKeyboardButton, CallbackQuery
from pyrogram.handlers import MessageHandler, CallbackQueryHandler
import json

#Local impports
import ExtractData
import Config

# Variables
bot = Client('FreeUploader', api_id=Config.API_ID, api_hash=Config.API_HASH, bot_token=Config.BOT_TOKEN) 
commands = filters.command  
            
#Botones inlines
START_BUTTONS = [
    [
        InlineKeyboardButton(text='Administrador', url=f'https://t.me/{Config.ADMIN_USER}'),
        InlineKeyboardButton(text='Acerca de', callback_data='about')
    ]
]

MY_ACCOUNT = [[InlineKeyboardButton("Resetear", callback_data='reset_account'),
                 InlineKeyboardButton("Borrar proxy", callback_data='delete_proxy')],
                [InlineKeyboardButton("Siguiente →", callback_data='next_page_account')]]

INFORMATION = [[InlineKeyboardButton("Mi cuenta", callback_data='my_acc'),
                 InlineKeyboardButton("Reporte", callback_data='report')],
                [InlineKeyboardButton("Información", callback_data='information')]]     
                
MY_ACCOUNT_2 = [[InlineKeyboardButton("Resetear", callback_data='reset_account'),
                 InlineKeyboardButton("Borrar proxy", callback_data='delete_proxy')],
                [InlineKeyboardButton("←Atras", callback_data='my_acc')]]
                
TOOLS = [
	[
		InlineKeyboardButton("Decriptar Proxy", callback_data='decrypt_proxy'),
                 InlineKeyboardButton("Encriptar Proxy", callback_data='encrypt_proxy')
    ],
    [
    	InlineKeyboardButton("Buscar Proxy", callback_data='search_proxy')
    ],
    [
    	InlineKeyboardButton("TestProxy", callback_data='test_proxy')
    ]
]
                                                             
# Acciones de los botones
#MY_ACCOUNT:
@bot.on_callback_query()
def callback_query(Client, CallbackQuery):
    query = CallbackQuery
    username = query.from_user.username
    if query.data == 'about':
    	msg = '__Interfaz aún en desarrollo__'
    	query.edit_message_text(msg)
    	
    if query.data == 'reset_account':
    	msg = '__Cuenta restablecida con exito!__'
    	query.edit_message_text(msg)
    	
    if query.data == 'delete_proxy':
    	msg = '__Proxy borrado...__'
    	query.edit_message_text(msg)
    	
    if query.data == 'my_acc':
    	msg = '**--Información general:--**\n'
    	msg += '**Dueño:** @' +username+ '\n'
    	msg += '**Status:** __Premium__\n\n'
    	msg += '**Username:** __none__\n'
    	msg += '**Password:** __node__\n'
    	msg += '**Host:** __none__ '
    	query.edit_message_text(msg, reply_markup=InlineKeyboardMarkup(MY_ACCOUNT))
    	
    if query.data == 'next_page_account':
    	msg = '**--Información de su instancia:--**\n'
    	msg += '**Dueño:** @' +username+ '\n'
    	msg += '**Admin:** __Si__\n\n'
    	msg += '**Proxy:** __Disabled__\n'
    	msg += '**UpToken:** __Disabled__\n'
    	msg += '**Zips:** __100MiB__\n'
    	msg += '**UpType:** __evidence__\n'
    	msg += '**CloudType:** __Moodle__\n'
    	query.edit_message_text(msg, reply_markup=InlineKeyboardMarkup(MY_ACCOUNT_2))
    	
    if query.data == 'report':
    	msg = '__Escriba su problema con el bot...__\n'
    	query.edit_message_text(msg)
    	
 
# Comandos

# VIEW UPDATE: 
#@bot.on_raw_update()
#async def raw(client, update, users, chats):
#    print(update)

@bot.on_message()
def start(client, message):
    sendMessage = message.reply
    editMessage = bot.edit_message_text
    chat_id = ExtractData.chat_id(message)
    username = ExtractData.username(message)
    msgText = ExtractData.get_messages(client, message)
    if "/start" in msgText:
        msg = '**Bienvenido a 𖤹 FreeUpZero 𖤹**'
        msg += '\n\n'
        msg += '**⚙️ Comandos de configuración**\n'
        msg += ' ├ /acc » Configurar cuenta moodle.\n'
        msg += ' ├ /host » configurar host de la cuenta.\n'
        msg += ' ├ /repo » Configurar ID de la nube.\n'
        msg += ' ├ /cloud » Configurar tipo de nube.\n'
        msg += ' ├ /uptype » Configurar tipo de subida.\n'
        msg += ' ├ /modo » Establecer configuración predeterminada.\n'
        msg += ' ├ /zip » Configurar tamaño de compresión.\n'
        msg += ' ├ /cfg_delete » Eliminar configuración de la cuenta.\n'
        msg += ' ╰ /off_proxy » Desactivar proxy.'
        msg += '\n\n'
        msg += '**ℹ️ Comandos de información**\n'
        msg += ' ├ /data » Obtener configuración de la cuenta.\n'
        msg += ' ├ /files » Obtener lista de archivos subidos.\n'
        msg += ' ├ /view_proxy » Obtener proxy configurado.\n'
        msg += ' ╰ /help » Obtener lista de comandos detallada.'
        msg += '\n\n'
        msg += '**Versión:** 1.0'
        message.reply(text=msg, reply_markup=InlineKeyboardMarkup(START_BUTTONS))
    
    elif "/info" in msgText:
        sms = message.text
        msg = '**--Información sobre el bot:--**\n'
        msg += '**Tiempo activo:** __none__\n'
        msg += '**Tempo restante:** __none__\n'
        msg += '**Administrador:** __UserZero075__\n'
        message.reply(text=msg, reply_markup=InlineKeyboardMarkup(INFORMATION))
        
    elif "/tools" in msgText:
        msg = '**--Herramientas:--**\n'
        message.reply(text=msg, reply_markup=InlineKeyboardMarkup(TOOLS))
	
print('Running FreeUploader...')
bot.run()